#include <bits/stdc++.h>
using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

// root: radice dell'albero, s: figlio della radice e punto di partenza per la visita
// mybfs: bfs che non passa per root (quindi visita il sottoalbero radicato nel nodo s)
// e conta i nodi raggiungibili da s
// print: flag, se true viene stampato l'elenco di questi nodi
int mybfs(int s, int root, vector<vector<pair<int,int>>>& graph, vector<bool>& visited, bool print){
    queue<int> q;
    q.push(s);
    visited[s] = true;
    int c = 1; 
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        if(print) out << v << endl;
        for(int i = 0; i<graph[v].size(); i++){
            int u = graph[v][i].first;
            if(!visited[u] && u != root){
                visited[u] = true;
                c++;
                q.push(u);
            }
        }
    }
    return c;
}


int main(){
    int n, m, s;
    in >> n >> m >> s;

    vector<vector<pair<int,int>>> graph(n);

    for(int i = 0; i<m; i++){
        int u, v, w;
        in >> u >> v >> w;
        graph[u].push_back(make_pair(v, w));
        graph[v].push_back(make_pair(u, w));
    }

    int res = 0, node;
    for(int i = 0; i<graph[s].size(); i++){
        int v = graph[s][i].first;
        vector<bool> visited(n, false);
        int curr = mybfs(v, s, graph, visited, false);
        if(curr > res){
            res = curr;
            node = v;
        }
    }

    out << res << endl;

    // stampo i nodi del sottoalbero radicato in s
    vector<bool> visited(n, false);
    mybfs(node, s, graph, visited, true); 

    return 0;
}





